/*  '**********************************************************************
    '*  Program  : DEMO01.C                                               *
    '*  Revision : C1                                                     *
    '*  Date     : 01/11/1996                       Advantech Co., Ltd.   *
    '*====================================================================*
    '*                                                                    *
    '*  This demo program performs software triggered one A/D conversion  *
    '*  and program control data transfer without using the MIC-2718      *
    '*  driver.                                                           *
    '*                                                                    *
    '**********************************************************************
*/
#include <stdio.h>
#include <dos.h>
char *gain_str[12]={"+/-5V","+/-0.5V","+/-0.05V","+/-0.005V","0-10V","0-1V",
		   "0-0.1V","0-0.01V","+/-10V","+/-1V","+/-0.1V","+/-0.01V"};
main()
{
 int status  ,s_end  ,start ,stop;
 int dtl ,dth ,adl   ,adt ,c_reg ,s_ch_val ,r_ch;
 int chv ,ch_gain[16];
 int port,val, i, j;
 port=0x200;              /* SET I/O PORT BASE ADDRESS */

/********** STEP 1: INITIALIZE & SELECT SOFTWARE TRIGGER *************/
 val=0x70;
 outportb(port+9,val);               /* software trigger */
 c_reg = inportb(port+9);
 if (c_reg != val)
     {
     printf("MIC-2718 hardware verification failed!\n");
     exit(0);
     }
 outportb(port+8,1);                 /* CLEAR INTERRUPT REQUEST  */

/*  ******** STEP 2: READ A/D STATUS REGISTER **************************** */

 status = inportb(port+8);
 if ((status & 0x20)==0x20)
     s_end = 1;
 else
     s_end = 0;

redo:
 if(s_end==1)
    {
    printf("\nenter start channel number <0-15> ");
    scanf("%d",&start);
    printf("enter stop channel number <0-15> ");
    scanf("%d",&stop);
    }
 else
    {
     printf("enter start channel number <0-7> ");
     scanf("%d",&start);
     printf("enter stop channel number <0-7> ");
     scanf("%d",&stop);
     }

 if ((s_end==0) & (stop>7))
     {
     printf("Entered channel failed! re-do!\n");
     goto redo;
     }

 if ((s_end==1) & (stop>15))
     {
     printf("Entered channel failed! re-do!\n");
     goto redo;
     }

 if (start > stop)
     {
     printf("Entered channel failed!\n");
     goto redo;
     }

/*********** STEP 3: SET A/D RANGE CODE *****************/

 printf("\n********************** A/D Range Code Table ********************\n");
 for(j=0; j<4; j++)
    {
    printf("*       ");
    for(i=0; i<3; i++)
       printf("%2d) %-12s",i+3*j,gain_str[i+3*j]);
    printf("       *\n");
    }
 for(i=0;i<8;i++)
    printf("********");
 puts("");

 for(i=start; i<=stop; i++)
    {
    printf("ENTER RANGE CODE <0 -- 11> OF CHANNEL %d :",i);
    scanf("%d",&ch_gain[i]);
    outportb(port+2, i);
    outportb(port+1, ch_gain[i]);
    printf("\n");
    }

/********* STEP 4: SET SCAN CHANNEL RANGE  ***********************/

 s_ch_val=stop*16+start;      /* SET SCAN CHANNEL VALUE */
 outportb(port+2,s_ch_val);
 r_ch = inportb(port+2);      /* READ BACK CHANNEL VALUE */
 if (r_ch != s_ch_val)
 {
     printf("Scan channel  setting failed!\n");
     exit(0);
 }
 delay(1);

/********* STEP 5: PERFORM SINGLE A/D CONVERSION  ***********/
 do {
    outportb(port+8,0);
    outportb(port,0);
reread:
    status = inport(port+8);
    if ((status & 0x10)==0x10)
       goto reread;
    delay(1);
    dtl = inportb(port);
    dth = inportb(port+1);
    adl = dtl/16;
    adt = dth*16+adl;
    chv = dtl-adl*16;
    printf("CURRENT CHANNEL=%2d   A/D RANGE=%-12s     "
           ,chv, gain_str[ch_gain[chv]]);
    if (( (ch_gain[chv]%8) > 3 ) )   /* larger 3 --> unipolar , 8=+/-10V*/
       printf("A/D DATA=%d\n",adt);
    else
       printf("A/D DATA=%d\n",adt);
    printf(" NEXT SCAN CHANNEL= %d\n",(status & 0x0f));
    printf("START SCAN CHANNEL= %d\n",start);
    printf(" STOP SCAN CHANNEL= %d\n",stop);
    printf("ENTER 'ESC' EXIT OR ANOTHER CONVERSION\n\n");
    } while(getche()!=27);
}
