{**********************************************************************
 *  Program  : FIFO.PAS                                               *
 *  Revision : C1                                                     *
 *  Date     : 01/11/1996                        Advantech Co., Ltd.  *
 *====================================================================*
 *                                                                    *
 *  This demo program performs software triggered one A/D conversion  *
 *  and program control data transfer through FIFO without using the  *
 *  MIC-2718 driver.                                                  *
 *                                                                    *
 **********************************************************************
}
program main;

label redo,restart,reread;
var     value,base:integer;
        bip,uni,c_reg,s_end,diff,st:integer;
        er,fun,ladr,req,rate,cycle,channel:integer;
        ch_gain,ch_num,i,j,msr,stop,start:integer;
        r_ch,s_ch_val,dtl,dth,adl,adt,chv:integer;
        divid,divisor1,divisor2:longint;
        number,symble1,symble2:char;


begin
    base:=$300;              {      SET I/O PORT BASE ADDRESS     }

{   ******** STEP 1: INITIALIZE & SELECT SOFTWARE TRIGGER ***************  }
{   PORT+9 ---- CONTROL REGISTER                                           }
    value:=$70;
    port[base+9]:=value;
    c_reg:=port[base+9];
    if c_reg <> value
      then
       begin
        writeln ('MIC-2718 hardware verification failed!');
        exit
       end
      else
         port[base+8]:=1;      {  CLEAR INTERRUPT REQUEST   }
         port[base+25]:=1;     {  CLEAR FIFO                }


{   ******** STEP 2: READ A/D STATUS REGISTER ****************************  }

    s_end:=0;
    st:=port[base+8];
    if ((st and $20)=$20)
    then
        s_end:= 1
    else
        diff:= 1;


redo: if (s_end=1)
         then
          begin
           write('ENTER START CHANNEL NUMBER <0-15> ');
           readln(start);
          end
          else
           begin
            write('ENTER START CHANNEL NUMBER <0-7> ');
            readln(start)
           end;
           writeln;

    if (s_end=1)
        then
         begin
           write('ENTER STOP CHANNEL NUMBER <0-15> ');
           readln(stop)
         end
        else
         begin
           write('ENTER STOP CHANNEL NUMBER <0-7> ');
           readln(stop)
         end;
    writeln('');
    if ((diff=1) and (stop>7))
        then
          begin
           writeln ('ENTERED CHANNEL FAILED! RE-DO!');
           goto redo
         end;

    if ((s_end=1) and (stop>15))
        then
          begin
           writeln('ENTERED CHANNEL FAILED! RE-DO!');
           goto redo
          end;
    if (start > stop)

        then
         begin
          writeln ('ENTERED CHANNEL FAILED!');
          goto redo
         end;

{********************* STEP 3: SET A/D RANGE CODE ********************}

    writeln('************** A/D Range Code Table *****************');
    writeln('*  0)+/-5V   1)+/-0.5V   2)+/-0.05V   3)+/-0.005V   *');
    writeln('*  4)0-10V   5)0-1V      6)0-0.1V     7)0-0.01V     *');
    writeln('*  8)+/-10V  9)+/-1V    10)+/-0.1V   11)+/-0.01V    *');
    writeln('*****************************************************');
    for i:=start to stop do
       begin
          write('ENTER A/D RANGE CODE <0 -- 11> OF CHANNEL  ',i,':');
          readln(ch_gain);
          port[base+2]:=i;
          port[base+1]:=ch_gain;
       end;

{******** STEP 4: SET SCAN CHANNEL RANGE  *******************}

    s_ch_val:=stop*16+start;     { SET SCAN CHANNEL VALUE  }
    port[base+2]:=s_ch_val;
    r_ch:=port[base+2];          { READ BACK CHANNEL VALUE  }
    if r_ch <> s_ch_val
      then
        begin
          writeln ('SET SCAN CHANNEL FAILED!');
          exit
        end;
    for i:=1 to 1000 do           { delay for a while }
       begin
       end;
{******** STEP 5: PERFORM SINGLE A/D CONVERSION  **********}
restart:
       port[base]:=0;             { SOFTWARE TRIGGER  }
reread:    st:=port[base+25];     { GET FIFO STATUA   }
    if (st and $01)=$01
        then
             goto reread;
    for i:=1 to 1000 do           { delay for a while }
       begin
       end;

       dtl:=port[base+23];        { READ LOW BYTE     }
       dth:=port[base+24];        { READ HIGH BYTE    }
       adl:=trunc(dtl/16);
       adt:=dth*16+adl;
       chv:=dtl-adl*16;
    if (uni=1) and (bip=0)
        then
          begin
          writeln ('CURRENT CHANNEL = ',chv);
          writeln ('');
          writeln('READING= ',adt);
          writeln('');
          end
        else
         begin
          WRITELN('');
          write('  CURRENT CHANNEL = ',chv);
          writeln('     READING= ',adt-2048);
          WRITELN('');
         end;

        writeln('NEXT SCAN CHANNEL = ',st and $f);
        writeln('START SCAN CHANNEL= ',start);
        writeln('STOP SCAN CHANNEL = ',stop);
        WRITELN('');
        writeln(' PRESS ANY KEY TO CONVERT ANOTHER CHANNEL, <e> TO EXIT');
        readln(number);
        if ((number<>'E') and (number<>'e'))
            then
                 goto restart;
end.{end}

